#include <stdio.h>
#include <stdlib.h>
#include <time.h>

// Struktúra az időzítő kezeléséhez
struct timespec start_time;
struct timespec end_time;

// Globális változó a függvényhívások számolásához
int function_call_count = 0;

// Instrumentation functions
void __attribute__((no_instrument_function)) __cyg_profile_func_enter(void *, void *func_addr) {
    clock_gettime(CLOCK_MONOTONIC, &start_time); // Az időzítő elindítása a függvénybelépési ponton
    function_call_count++;
}

void __attribute__((no_instrument_function)) __cyg_profile_func_exit(void *, void *func_addr) {
    clock_gettime(CLOCK_MONOTONIC, &end_time); // Az időzítő leállítása a függvénykilépési ponton
    double elapsed_time = (end_time.tv_sec - start_time.tv_sec) + (end_time.tv_nsec - start_time.tv_nsec) / 1e9; // Az eltelt idő kiszámítása másodpercben
    printf("Function ran for %.6f seconds\n", elapsed_time);
}

// Example functions
void foo() {
    printf("Inside foo()\n");
    // Egy kis várakozás hozzáadása a futási idő méréséhez
    for (int i = 0; i < 100000000; i++) {
        // Üres ciklus csak a várakozáshoz
    }
}

void bar() {
    printf("Inside bar()\n");
}

int main() {
    foo();
    bar();
    
    printf("Total function calls: %d\n", function_call_count);
    
    return 0;
}
